Bug 469460 - review request: gir-repository - GObject Introspection Repository
review request: gir-repository - GObject Introspection Repository
Status: CLOSED RAWHIDE
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Owen Taylor
Fedora Extras Quality Assurance
:
Depends On:
Blocks: 508318
  Show dependency treegraph
 
Reported: 2008-10-31 19:59 EDT by Colin Walters
Modified: 2016-01-12 18:58 EST (History)
7 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2009-07-14 09:47:24 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
otaylor: fedora‑review+
kevin: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description Colin Walters 2008-10-31 19:59:30 EDT
Spec: http://cdn.verbum.org/gir-repository.spec
SRPM: http://cdn.verbum.org/gir-repository-0.6.0-1.svn20081031.r190.fc10.src.rpm

Note there are rpmlint errors of the form:
gir-repository.x86_64: E: invalid-soname /usr/lib64/libgirepo-Clutter-custom.so libgirepo-Clutter-custom.so

These should be safely ignorable because these custom libraries are not linked to directly; they will be dlopen()ed by the introspection system.  They are also a temporary hack (like all of gir-repository) until we get the changes upstreamed.
Comment 1 Owen Taylor 2008-11-03 19:06:36 EST
Looks very good in general. Couple of small problem.

X - COPYING file upstream needs fixing
X - Missing requiements on gobject-introspection[-devel] for directories
X - Shouldn't own %{_datadir}/gir

Details below.

Also, I really don't like "metadata" at all for this as I said in the
gobject-intropsection API review. We don't need to overload that term more. 
Can you change the summary/descriptions to say "introspection data"?

[*] OK or not applicable
[X] Problem
[-] Not checked

Musts
======
[*] rpmlint must be run on every package. The output should be posted in the
review.
gir-repository.spec: W: mixed-use-of-spaces-and-tabs (spaces: line 1, tab: line 6)
0 packages and 1 specfiles checked; 0 errors, 1
[*] The package must be named according to the  Package Naming Guidelines .
[*] The spec file name must match the base package %{name}, in the format
%{name}.spec unless your package has an exemption on Package Naming Guidelines
.
[*] MUST: The package must meet the Packaging Guidelines .
[*] The package must be licensed with a Fedora approved license and meet the
Licensing Guidelines .
[X] The License field in the package spec file must match the actual license.

COPYING in the distro is GPLv2+, no other indication of license.

[*] If (and only if) the source package includes the text of the license(s) in
its own file, then that file, containing the text of the license(s) for the
package must be included in %doc.
[*] The spec file must be written in American English.
[*] The spec file for the package MUST be legible. If the reviewer is unable to
read the spec file, it will be impossible to perform a review. Fedora is not
the place for entries into the Obfuscated Code Contest (http://www.ioccc.org/).
[-] The sources used to build the package must match the upstream source, as
provided in the spec URL.

SVN snapshot

[*] The package must successfully compile and build into binary rpms on at
least one supported architecture.
[*] If the package does not successfully compile, build or work on an
architecture, then those architectures should be listed in the spec in
ExcludeArch. 
[*] All build dependencies must be listed in BuildRequires, except for any that
are listed in the exceptions section of the Packaging Guidelines ; inclusion of
those as BuildRequires is optional. Apply common sense.
[*] The spec file MUST handle locales properly. 
[*] Every binary RPM package which stores shared library files (not just
symlinks) in any of the dynamic linker's default paths, must call ldconfig in
%post and %postun. 
[*] If the package is designed to be relocatable, the packager must state this
fact in the request for review, along with the rationalization for relocation
of that specific package. Without this, use of Prefix: /usr is considered a
blocker.
[X] A package must own all directories that it creates. If it does not create a
directory that it uses, then it should require a package which does create that
directory. Refer to the Guidelines for examples.

main package require gobject-introspection for %{libdir}/girepository.

Devel should require gobject-introspection-devel and have %{_datadir}/gir/* 
in the file list since the directory is coming from
gobject-introspection-devel. 

[*] A package must not contain any duplicate files in the %files listing.
[*] Permissions on files must be set properly. Executables should be set with
executable permissions, for example. Every %files section must include a
%defattr(...) line.
[*] Each package must have a %clean section, which contains rm -rf %{buildroot}
( or $RPM_BUILD_ROOT ).
[*] Each package must consistently use macros, as described in the macros
section of Packaging Guidelines .
[*] The package must contain code, or permissable content. This is described in
detail in the code vs. content section of Packaging Guidelines .
[*] Large documentation files should go in a -doc subpackage. (The definition
of large is left up to the packager's best judgement, but is not restricted to
size. Large can refer to either size or quantity)
[*] If a package includes something as %doc, it must not affect the runtime of
the application. To summarize: If it is in %doc, the program must run properly
if it is not present.
[*] Header files must be in a -devel package.
[*] Static libraries must be in a -static package.
[*] Packages containing pkgconfig(.pc) files must 'Requires: pkgconfig' (for
directory ownership and usability).
[*] If a package contains library files with a suffix (e.g. libfoo.so.1.1),
then library files that end in .so (without suffix) must go in a -devel
package.

OK exception IMO. (I think the the .so files at least need the API version
in them .. /usr/lib/libgirepo-Clutter-custom.so should have 0.8 in the
name somewhere. But that's an upstream issue.)

[*] In the vast majority of cases, devel packages must require the base package
using a fully versioned dependency: Requires: %{name} = %{version}-%{release}
[*] Packages must NOT contain any .la libtool archives, these should be removed
in the spec.
[*] Packages containing GUI applications must include a %{name}.desktop file,
and that file must be properly installed with desktop-file-install in the
%install section. This is described in detail in the desktop files section of
the Packaging Guidelines . If you feel that your packaged GUI application does
not need a .desktop file, you must put a comment in the spec file with your
explanation.
[X] Packages must not own files or directories already owned by other packages.
The rule of thumb here is that the first package to be installed should own the
files or directories that other packages may rely upon. This means, for
example, that no package in Fedora should ever share ownership with any of the
files or directories owned by the filesystem or man package. If you feel that
you have a good reason to own a file or directory that another package owns,
then please present that at package review time.

See above.

[*] At the beginning of %install, each package MUST run rm -rf %{buildroot} (
or $RPM_BUILD_ROOT ). See Prepping BuildRoot For %install for details.
See above
[*] All filenames in rpm packages must be valid UTF-8.

Should
======
[*] If the source package does not include license text(s) as a separate file
from upstream, the packager SHOULD query upstream to include it.
[*] The description and summary sections in the package spec file should
contain translations for supported Non-English languages, if available.
[-] The reviewer should test that the package builds in mock. See MockTricks
for details on how to do this.

Hard to do since gobject-introspection isn't yet in rawhide.

[-] The package should compile and build into binary rpms on all supported
architectures.
[-] The reviewer should test that the package functions as described. A package
should not segfault instead of running, for example.
[*] If scriptlets are used, those scriptlets must be sane. This is vague, and
left up to the reviewers judgement to determine sanity.
[*] Usually, subpackages other than devel should require the base package using
a fully versioned dependency.
[*] The placement of pkgconfig(.pc) files depends on their usecase, and this is
usually for development purposes, so should be placed in a -devel pkg. A
reasonable exception is that the main pkg itself is a devel tool not installed
in a user runtime, e.g. gcc or gdb.
[*] If the package has file dependencies outside of /etc, /bin, /sbin,
/usr/bin, or /usr/sbin consider requiring the package which provides the file
instead of the file itself. Please see File Dependencies in the Guidelines for
further information.
Comment 2 Colin Walters 2008-11-04 16:21:49 EST
Thanks for the review.  I've fixed these two problems locally.  Also changed the summary.  

http://cdn.verbum.org/gir-repository.spec
Comment 3 Colin Walters 2008-12-11 16:55:15 EST
Ping on this review.
Comment 4 Owen Taylor 2008-12-15 15:24:43 EST
Doesn't look like:

 main package should require gobject-introspection for %{libdir}/girepository.

was fixed. New Summary/Description:

Summary:        Introspection for GNOME libraries
%description
Introspection system for GNOME libraries; see the gobject-introspection package.

are a bit weird. (I'd use "information" or "data" in both places.)

Generally looks fine though.
Comment 5 Colin Walters 2008-12-16 09:55:52 EST
New Package CVS Request
=======================
Package Name: gir-repository
Short Description: Introspection system for GNOME libraries
Owners: walters@verbum.org,otaylor@redhat.com
Branches: F-10
InitialCC:
Comment 6 Kevin Fenzi 2008-12-17 16:48:33 EST
Please use Fedora account names in requests. 

cvs done.
Comment 7 Rakesh Pandit 2009-06-01 01:16:18 EDT
May you import it as soon as possible, I am looking to package whole gnome-shell and stack packages and dependencies and this is blocker .. please update to latest stable release ?

Thanks,
Comment 8 Peter Robinson 2009-06-29 05:56:10 EDT
walters: It seems this has been committed to cvs but not built. Any issues with my updating it to the latest release and building it?
Comment 9 Colin Walters 2009-06-30 09:52:19 EDT
I've updated CVS.  Working on a mock test build now, but feel free to jujmp in and make any changes necessary.
Comment 10 Peter Robinson 2009-06-30 11:19:39 EDT
(In reply to comment #9)
> I've updated CVS.  Working on a mock test build now, but feel free to jujmp in
> and make any changes necessary.  

I'll have a look tonight if you don't have time. I was in process of getting them both on 0.6.3 (inc gobject-introspection) earlier but other things have taken my time.
Comment 11 Rakesh Pandit 2009-07-02 00:58:18 EDT
from comment#7

I had communicated via email long back here .. but no response ... have requested for co-maintainership so that I can import it and build .. Peter in case you get some time go ahead .. or in case it is not build in few days I will import it and build.

Thanks folks,
Comment 12 Peter Robinson 2009-07-02 04:01:05 EDT
I would have built it yesterday but it needs to be the same version as gobject-introspection and the 0.6.3 release of that has issues on PPC64 (builds fine on all other 3 platforms) which I haven't had a chance to investigate further or put out to the mailing list.
Comment 13 Peter Robinson 2009-07-07 07:06:28 EDT
Built in rawhide:
http://koji.fedoraproject.org/koji/taskinfo?taskID=1458565
Comment 14 Peter Robinson 2009-07-14 09:47:24 EDT
Closing as its now in rawhide

Note You need to log in before you can comment on or make changes to this bug.